diff --git a/oflog/libsrc/fileap.cc b/oflog/libsrc/fileap.cc
index 20cb28a..013a41f 100644
--- a/oflog/libsrc/fileap.cc
+++ b/oflog/libsrc/fileap.cc
@@ -4,7 +4,7 @@
 // Author:  Tad E. Smith
 //
 //
-// Copyright 2001-2009 Tad E. Smith
+// Copyright 2001-2010 Tad E. Smith
 //
 // Licensed under the Apache License, Version 2.0 (the "License");
 // you may not use this file except in compliance with the License.
@@ -24,27 +24,38 @@
 #include "dcmtk/oflog/helpers/loglog.h"
 #include "dcmtk/oflog/helpers/strhelp.h"
 #include "dcmtk/oflog/helpers/timehelp.h"
+#include "dcmtk/oflog/helpers/property.h"
+#include "dcmtk/oflog/helpers/fileinfo.h"
 #include "dcmtk/oflog/spi/logevent.h"
-//#include <algorithm>
-
-//#include <cstdio>
-#define INCLUDE_CSTDIO
-//#include <cerrno>
-#define INCLUDE_CERRNO
-//#include <cstdlib>
-#define INCLUDE_CSTDLIB
-
-#include "dcmtk/ofstd/ofstdinc.h"
+#include "dcmtk/oflog/spi/factory.h"
+#include "dcmtk/oflog/thread/syncpub.h"
+#include "dcmtk/oflog/internal/internal.h"
+#include <algorithm>
+#include <sstream>
+#include <cstdio>
+#include <stdexcept>
+
+#if defined (__BORLANDC__)
+// For _wrename() and _wremove() on Windows.
+#  include <stdio.h>
+#endif
+#include <cerrno>
+#ifdef DCMTK_LOG4CPLUS_HAVE_ERRNO_H
+#include <errno.h>
+#endif
 
-using namespace dcmtk::log4cplus::helpers;
+#define MAX(a, b) ((a) < (b) ? (b) : (a))
 
 namespace dcmtk
 {
-
 namespace log4cplus
 {
 
+using helpers::Properties;
+using helpers::Time;
+
 
+const long DEFAULT_ROLLING_LOG_SIZE = 10 * 1024 * 1024L;
 const long MINIMUM_ROLLING_LOG_SIZE = 200*1024L;
 
 
@@ -55,57 +66,86 @@ const long MINIMUM_ROLLING_LOG_SIZE = 200*1024L;
 namespace
 {
 
-static
-int
+long const DCMTK_LOG4CPLUS_FILE_NOT_FOUND = ENOENT;
+
+
+static 
+long
 file_rename (tstring const & src, tstring const & target)
 {
-    return rename (DCMTK_LOG4CPLUS_TSTRING_TO_STRING (src).c_str (),
-        DCMTK_LOG4CPLUS_TSTRING_TO_STRING (target).c_str ()) == 0 ? 0 : -1;
+#if defined (UNICODE) && defined (_WIN32)
+    if (_wrename (src.c_str (), target.c_str ()) == 0)
+        return 0;
+    else
+        return errno;
+
+#else
+    if (rename (DCMTK_LOG4CPLUS_TSTRING_TO_STRING (src).c_str (),
+            DCMTK_LOG4CPLUS_TSTRING_TO_STRING (target).c_str ()) == 0)
+        return 0;
+    else
+        return errno;
+
+#endif
 }
 
 
 static
-int
+long
 file_remove (tstring const & src)
 {
-    return remove (DCMTK_LOG4CPLUS_TSTRING_TO_STRING (src).c_str ()) == 0
-        ? 0 : -1;
+#if defined (UNICODE) && defined (_WIN32)
+    if (_wremove (src.c_str ()) == 0)
+        return 0;
+    else
+        return errno;
+
+#else
+    if (remove (DCMTK_LOG4CPLUS_TSTRING_TO_STRING (src).c_str ()) == 0)
+        return 0;
+    else
+        return errno;
+
+#endif
 }
 
 
 static
 void
-loglog_renaming_result (LogLog & loglog, tstring const & src,
-    tstring const & target, int ret)
+loglog_renaming_result (helpers::LogLog & loglog, tstring const & src,
+    tstring const & target, long ret)
 {
     if (ret == 0)
     {
         loglog.debug (
-            DCMTK_LOG4CPLUS_TEXT("Renamed file ")
-            + src
+            DCMTK_LOG4CPLUS_TEXT("Renamed file ") 
+            + src 
             + DCMTK_LOG4CPLUS_TEXT(" to ")
             + target);
     }
-    else if (ret == -1 && errno != ENOENT)
+    else if (ret != DCMTK_LOG4CPLUS_FILE_NOT_FOUND)
     {
-        loglog.error (
-            DCMTK_LOG4CPLUS_TEXT("Failed to rename file from ")
-            + target
-            + DCMTK_LOG4CPLUS_TEXT(" to ")
-            + target);
+        tostringstream oss;
+        oss << DCMTK_LOG4CPLUS_TEXT("Failed to rename file from ")
+            << src
+            << DCMTK_LOG4CPLUS_TEXT(" to ")
+            << target
+            << DCMTK_LOG4CPLUS_TEXT("; error ")
+            << ret;
+        loglog.error (OFString(oss.str().c_str(), oss.str().length()));
     }
 }
 
 
 static
 void
-loglog_opening_result (LogLog & loglog,
-    tostream const & os, tstring const & filename)
+loglog_opening_result (helpers::LogLog & loglog,
+    log4cplus::tostream const & os, tstring const & filename)
 {
     if (! os)
     {
         loglog.error (
-            DCMTK_LOG4CPLUS_TEXT("Failed to open file ")
+            DCMTK_LOG4CPLUS_TEXT("Failed to open file ") 
             + filename);
     }
 }
@@ -115,14 +155,12 @@ static
 void
 rolloverFiles(const tstring& filename, unsigned int maxBackupIndex)
 {
-    SharedObjectPtr<LogLog> loglog
-        = LogLog::getLogLog();
+    helpers::LogLog * loglog = helpers::LogLog::getLogLog();
 
     // Delete the oldest file
     tostringstream buffer;
     buffer << filename << DCMTK_LOG4CPLUS_TEXT(".") << maxBackupIndex;
-    OFSTRINGSTREAM_GETOFSTRING(buffer, buffer_str)
-    int ret = file_remove (buffer_str);
+    long ret = file_remove (OFString(buffer.str().c_str(), buffer.str().length()));
 
     tostringstream source_oss;
     tostringstream target_oss;
@@ -136,8 +174,8 @@ rolloverFiles(const tstring& filename, unsigned int maxBackupIndex)
         source_oss << filename << DCMTK_LOG4CPLUS_TEXT(".") << i;
         target_oss << filename << DCMTK_LOG4CPLUS_TEXT(".") << (i+1);
 
-        OFSTRINGSTREAM_GETOFSTRING(source_oss, source)
-        OFSTRINGSTREAM_GETOFSTRING(target_oss, target)
+        tstring const source (OFString(source_oss.str().c_str(), source_oss.str().length()));
+        tstring const target (OFString(target_oss.str().c_str(), target_oss.str().length()));
 
 #if defined (_WIN32)
         // Try to remove the target first. It seems it is not
@@ -150,67 +188,132 @@ rolloverFiles(const tstring& filename, unsigned int maxBackupIndex)
     }
 } // end rolloverFiles()
 
+
+static
+STD_NAMESPACE locale
+get_locale_by_name (tstring const & locale_name)
+{
+    try {
+        spi::LocaleFactoryRegistry & reg = spi::getLocaleFactoryRegistry ();
+        spi::LocaleFactory * fact = reg.get (locale_name);
+        if (fact)
+        {
+            helpers::Properties props;
+            props.setProperty (DCMTK_LOG4CPLUS_TEXT ("Locale"), locale_name);
+            return fact->createObject (props);
+        }
+        else
+            return STD_NAMESPACE locale (DCMTK_LOG4CPLUS_TSTRING_TO_STRING (locale_name).c_str ());
+    }
+    catch (STD_NAMESPACE runtime_error const &)
+    {
+        helpers::getLogLog ().error (
+            DCMTK_LOG4CPLUS_TEXT ("Failed to create locale " + locale_name));
+        return STD_NAMESPACE locale ();
+    }
 }
 
+} // namespace
+
 
 ///////////////////////////////////////////////////////////////////////////////
 // FileAppender ctors and dtor
 ///////////////////////////////////////////////////////////////////////////////
 
-FileAppender::FileAppender(const tstring& filename_,
-    DCMTK_LOG4CPLUS_OPEN_MODE_TYPE mode, bool immediateFlush_)
+FileAppender::FileAppender(const tstring& filename_, 
+    STD_NAMESPACE ios_base::openmode mode_, bool immediateFlush_)
     : immediateFlush(immediateFlush_)
     , reopenDelay(1)
+    , bufferSize (0)
+    , buffer (0)
+    , out ()
+    , filename ()
+    , localeName (DCMTK_LOG4CPLUS_TEXT ("DEFAULT"))
+    , reopen_time ()
 {
-    init(filename_, mode);
+    init(filename_, mode_, internal::empty_str);
 }
 
 
-FileAppender::FileAppender(const Properties& properties,
-                           tstring&,
-                           DCMTK_LOG4CPLUS_OPEN_MODE_TYPE mode)
-    : Appender(properties)
+FileAppender::FileAppender(const Properties& props, 
+                           STD_NAMESPACE ios_base::openmode mode_)
+    : Appender(props)
     , immediateFlush(true)
     , reopenDelay(1)
+    , bufferSize (0)
+    , buffer (0)
+    , out ()
+    , filename ()
+    , localeName ()
+    , reopen_time ()
 {
-    bool append_ = (mode == STD_NAMESPACE ios::app);
-    tstring filename_ = properties.getProperty( DCMTK_LOG4CPLUS_TEXT("File") );
-    if (filename_.empty())
+    bool app = (mode_ == STD_NAMESPACE ios::app);
+    tstring const & fn = props.getProperty( DCMTK_LOG4CPLUS_TEXT("File") );
+    if (fn.empty())
     {
         getErrorHandler()->error( DCMTK_LOG4CPLUS_TEXT("Invalid filename") );
         return;
     }
-    if(properties.exists( DCMTK_LOG4CPLUS_TEXT("ImmediateFlush") )) {
-        tstring tmp = properties.getProperty( DCMTK_LOG4CPLUS_TEXT("ImmediateFlush") );
-        immediateFlush = (toLower(tmp) == DCMTK_LOG4CPLUS_TEXT("true"));
-    }
-    if(properties.exists( DCMTK_LOG4CPLUS_TEXT("Append") )) {
-        tstring tmp = properties.getProperty( DCMTK_LOG4CPLUS_TEXT("Append") );
-        append_ = (toLower(tmp) == DCMTK_LOG4CPLUS_TEXT("true"));
-    }
-    if(properties.exists( DCMTK_LOG4CPLUS_TEXT("ReopenDelay") )) {
-        tstring tmp = properties.getProperty( DCMTK_LOG4CPLUS_TEXT("ReopenDelay") );
-        reopenDelay = atoi(DCMTK_LOG4CPLUS_TSTRING_TO_STRING(tmp).c_str());
+
+    props.getBool (immediateFlush, DCMTK_LOG4CPLUS_TEXT("ImmediateFlush"));
+    props.getBool (app, DCMTK_LOG4CPLUS_TEXT("Append"));
+    props.getInt (reopenDelay, DCMTK_LOG4CPLUS_TEXT("ReopenDelay"));
+    props.getULong (bufferSize, DCMTK_LOG4CPLUS_TEXT("BufferSize"));
+
+    tstring lockFileName = props.getProperty (DCMTK_LOG4CPLUS_TEXT ("LockFile"));
+    if (useLockFile && lockFileName.empty ())
+    {
+        lockFileName = fn;
+        lockFileName += DCMTK_LOG4CPLUS_TEXT(".lock");
     }
 
-    init(filename_, (append_ ? STD_NAMESPACE ios::app : STD_NAMESPACE ios::trunc));
+    localeName = props.getProperty (DCMTK_LOG4CPLUS_TEXT ("Locale"),
+        DCMTK_LOG4CPLUS_TEXT ("DEFAULT"));
+
+    init(fn, (app ? STD_NAMESPACE ios::app : STD_NAMESPACE ios::trunc), lockFileName);
 }
 
 
 
 void
-FileAppender::init(const tstring& filename_,
-                   DCMTK_LOG4CPLUS_OPEN_MODE_TYPE mode)
+FileAppender::init(const tstring& filename_, 
+                   STD_NAMESPACE ios_base::openmode mode_,
+                   const log4cplus::tstring& lockFileName_)
 {
-    this->filename = filename_;
-    open(mode);
+    filename = filename_;
+
+    if (bufferSize != 0)
+    {
+        delete[] buffer;
+        buffer = new tchar[bufferSize];
+        out.rdbuf ()->pubsetbuf (buffer, bufferSize);
+    }
+
+    helpers::LockFileGuard guard;
+    if (useLockFile && ! lockFile.get ())
+    {
+        try
+        {
+            lockFile.reset (new helpers::LockFile (lockFileName_));
+            guard.attach_and_lock (*lockFile);
+        }
+        catch (STD_NAMESPACE runtime_error const &)
+        {
+            // We do not need to do any logging here as the internals
+            // of LockFile already use LogLog to report the failure.
+            return;
+        }
+    }
+
+    open(mode_);
+    imbue (get_locale_by_name (localeName));
 
     if(!out.good()) {
-        getErrorHandler()->error(  DCMTK_LOG4CPLUS_TEXT("Unable to open file: ")
+        getErrorHandler()->error(  DCMTK_LOG4CPLUS_TEXT("Unable to open file: ") 
                                  + filename);
         return;
     }
-    getLogLog().debug(DCMTK_LOG4CPLUS_TEXT("Just opened file: ") + filename);
+    helpers::getLogLog().debug(DCMTK_LOG4CPLUS_TEXT("Just opened file: ") + filename);
 }
 
 
@@ -226,16 +329,31 @@ FileAppender::~FileAppender()
 // FileAppender public methods
 ///////////////////////////////////////////////////////////////////////////////
 
-void
+void 
 FileAppender::close()
 {
-    DCMTK_LOG4CPLUS_BEGIN_SYNCHRONIZE_ON_MUTEX( access_mutex )
-        out.close();
-        closed = true;
-    DCMTK_LOG4CPLUS_END_SYNCHRONIZE_ON_MUTEX;
+    thread::MutexGuard guard (access_mutex);
+
+    out.close();
+    delete[] buffer;
+    buffer = 0;
+    closed = true;
+}
+
+
+STD_NAMESPACE locale
+FileAppender::imbue(STD_NAMESPACE locale const& loc)
+{
+    return out.imbue (loc);
 }
 
 
+STD_NAMESPACE locale
+FileAppender::getloc () const
+{
+    return out.getloc ();
+}
+
 
 ///////////////////////////////////////////////////////////////////////////////
 // FileAppender protected methods
@@ -248,26 +366,29 @@ FileAppender::append(const spi::InternalLoggingEvent& event)
 {
     if(!out.good()) {
         if(!reopen()) {
-            getErrorHandler()->error(  DCMTK_LOG4CPLUS_TEXT("file is not open: ")
+            getErrorHandler()->error(  DCMTK_LOG4CPLUS_TEXT("file is not open: ") 
                                      + filename);
             return;
         }
-        // Resets the error handler to make it
+        // Resets the error handler to make it 
         // ready to handle a future append error.
         else
             getErrorHandler()->reset();
     }
 
+    if (useLockFile)
+        out.seekp (0, STD_NAMESPACE ios_base::end);
+
     layout->formatAndAppend(out, event);
-    if(immediateFlush) {
+
+    if(immediateFlush || useLockFile)
         out.flush();
-    }
 }
 
 void
 FileAppender::open(STD_NAMESPACE ios::openmode mode)
 {
-    out.open(DCMTK_LOG4CPLUS_TSTRING_TO_STRING(filename).c_str(), mode);
+    out.open(DCMTK_LOG4CPLUS_FSTREAM_PREFERED_FILE_NAME(filename).c_str(), mode);
 }
 
 bool
@@ -275,25 +396,26 @@ FileAppender::reopen()
 {
     // When append never failed and the file re-open attempt must
     // be delayed, set the time when reopen should take place.
-    if (reopen_time == Time () && reopenDelay != 0)
-        reopen_time = Time::gettimeofday()
-			+ Time(reopenDelay);
+    if (reopen_time == log4cplus::helpers::Time () && reopenDelay != 0)
+        reopen_time = log4cplus::helpers::Time::gettimeofday()
+            + log4cplus::helpers::Time(reopenDelay);
     else
-	{
-        // Otherwise, check for end of the delay (or absence of delay) to re-open the file.
-        if (reopen_time <= Time::gettimeofday()
-			|| reopenDelay == 0)
-		{
+    {
+        // Otherwise, check for end of the delay (or absence of delay)
+        // to re-open the file.
+        if (reopen_time <= log4cplus::helpers::Time::gettimeofday()
+            || reopenDelay == 0)
+        {
             // Close the current file
             out.close();
             out.clear(); // reset flags since the C++ standard specified that all the
                          // flags should remain unchanged on a close
 
             // Re-open the file.
-            open(STD_NAMESPACE ios::app);
+            open(STD_NAMESPACE ios_base::out | STD_NAMESPACE ios_base::ate);
 
             // Reset last fail time.
-            reopen_time = Time ();
+            reopen_time = log4cplus::helpers::Time ();
 
             // Succeed if no errors are found.
             if(out.good())
@@ -309,35 +431,39 @@ FileAppender::reopen()
 
 RollingFileAppender::RollingFileAppender(const tstring& filename_,
     long maxFileSize_, int maxBackupIndex_, bool immediateFlush_)
-    : FileAppender(filename_, STD_NAMESPACE ios::app, immediateFlush_)
+    : FileAppender(filename_, STD_NAMESPACE ios::app, immediateFlush_), maxFileSize (), maxBackupIndex ()
 {
     init(maxFileSize_, maxBackupIndex_);
 }
 
 
-RollingFileAppender::RollingFileAppender(const Properties& properties, tstring& error)
-    : FileAppender(properties, error, STD_NAMESPACE ios::app)
+RollingFileAppender::RollingFileAppender(const Properties& properties)
+    : FileAppender(properties, STD_NAMESPACE ios::app), maxFileSize (), maxBackupIndex ()
 {
-    int maxFileSize_ = 10*1024*1024;
-    int maxBackupIndex_ = 1;
-    if(properties.exists( DCMTK_LOG4CPLUS_TEXT("MaxFileSize") )) {
-        tstring tmp = properties.getProperty( DCMTK_LOG4CPLUS_TEXT("MaxFileSize") );
-        tmp = toUpper(tmp);
-        maxFileSize_ = atoi(DCMTK_LOG4CPLUS_TSTRING_TO_STRING(tmp).c_str());
-        if(tmp.find( DCMTK_LOG4CPLUS_TEXT("MB") ) == (tmp.length() - 2)) {
-            maxFileSize_ *= (1024 * 1024); // convert to megabytes
-        }
-        if(tmp.find( DCMTK_LOG4CPLUS_TEXT("KB") ) == (tmp.length() - 2)) {
-            maxFileSize_ *= 1024; // convert to kilobytes
+    long tmpMaxFileSize = DEFAULT_ROLLING_LOG_SIZE;
+    int tmpMaxBackupIndex = 1;
+    tstring tmp (
+        helpers::toUpper (
+            properties.getProperty (DCMTK_LOG4CPLUS_TEXT ("MaxFileSize"))));
+    if (! tmp.empty ())
+    {
+        tmpMaxFileSize = atoi(DCMTK_LOG4CPLUS_TSTRING_TO_STRING(tmp).c_str());
+        if (tmpMaxFileSize != 0)
+        {
+            tstring::size_type const len = tmp.length();
+            if (len > 2
+                && tmp.compare (len - 2, 2, DCMTK_LOG4CPLUS_TEXT("MB")) == 0)
+                tmpMaxFileSize *= (1024 * 1024); // convert to megabytes
+            else if (len > 2
+                && tmp.compare (len - 2, 2, DCMTK_LOG4CPLUS_TEXT("KB")) == 0)
+                tmpMaxFileSize *= 1024; // convert to kilobytes
         }
+        tmpMaxFileSize = MAX(tmpMaxFileSize, MINIMUM_ROLLING_LOG_SIZE);
     }
 
-    if(properties.exists( DCMTK_LOG4CPLUS_TEXT("MaxBackupIndex") )) {
-        tstring tmp = properties.getProperty(DCMTK_LOG4CPLUS_TEXT("MaxBackupIndex"));
-        maxBackupIndex_ = atoi(DCMTK_LOG4CPLUS_TSTRING_TO_STRING(tmp).c_str());
-    }
+    properties.getInt (tmpMaxBackupIndex, DCMTK_LOG4CPLUS_TEXT("MaxBackupIndex"));
 
-    init(maxFileSize_, maxBackupIndex_);
+    init(tmpMaxFileSize, tmpMaxBackupIndex);
 }
 
 
@@ -350,15 +476,12 @@ RollingFileAppender::init(long maxFileSize_, int maxBackupIndex_)
         oss << DCMTK_LOG4CPLUS_TEXT ("RollingFileAppender: MaxFileSize property")
             DCMTK_LOG4CPLUS_TEXT (" value is too small. Resetting to ")
             << MINIMUM_ROLLING_LOG_SIZE << ".";
-        OFSTRINGSTREAM_GETSTR(oss, str)
-        getLogLog().warn(str);
-        OFSTRINGSTREAM_FREESTR(str)
+        helpers::getLogLog ().warn (OFString(oss.str().c_str(), oss.str().length()));
         maxFileSize_ = MINIMUM_ROLLING_LOG_SIZE;
     }
-    this->maxFileSize = maxFileSize_;
-    if (maxBackupIndex_ < 1)
-        maxBackupIndex_ = 1;
-    this->maxBackupIndex = maxBackupIndex_;
+
+    maxFileSize = maxFileSize_;
+    maxBackupIndex = MAX(maxBackupIndex_, 1);
 }
 
 
@@ -380,20 +503,54 @@ RollingFileAppender::append(const spi::InternalLoggingEvent& event)
     FileAppender::append(event);
 
     if(out.tellp() > maxFileSize) {
-        rollover();
+        rollover(true);
     }
 }
 
 
 void
-RollingFileAppender::rollover()
+RollingFileAppender::rollover(bool alreadyLocked)
 {
-    LogLog & loglog = getLogLog();
+    helpers::LogLog & loglog = helpers::getLogLog();
+    helpers::LockFileGuard guard;
 
     // Close the current file
     out.close();
-    out.clear(); // reset flags since the C++ standard specified that all the
-                 // flags should remain unchanged on a close
+    // Reset flags since the C++ standard specified that all the flags
+    // should remain unchanged on a close.
+    out.clear(); 
+
+    if (useLockFile)
+    {
+        if (! alreadyLocked)
+        {
+            try
+            {
+                guard.attach_and_lock (*lockFile);
+            }
+            catch (STD_NAMESPACE runtime_error const &)
+            {
+                return;
+            }
+        }
+
+        // Recheck the condition as there is a window where another
+        // process can rollover the file before us.
+
+        helpers::FileInfo fi;
+        if (helpers::getFileInfo (&fi, filename) == -1
+            || fi.size < maxFileSize)
+        {
+            // The file has already been rolled by another
+            // process. Just reopen with the new file.
+
+            // Open it up again.
+            open (STD_NAMESPACE ios::out | STD_NAMESPACE ios::ate);
+            loglog_opening_result (loglog, out, filename);
+
+            return;
+        }
+    }
 
     // If maxBackups <= 0, then there is no file renaming to be done.
     if (maxBackupIndex > 0)
@@ -403,7 +560,7 @@ RollingFileAppender::rollover()
         // Rename fileName to fileName.1
         tstring target = filename + DCMTK_LOG4CPLUS_TEXT(".1");
 
-        int ret;
+        long ret;
 
 #if defined (_WIN32)
         // Try to remove the target first. It seems it is not
@@ -412,8 +569,8 @@ RollingFileAppender::rollover()
 #endif
 
         loglog.debug (
-            DCMTK_LOG4CPLUS_TEXT("Renaming file ")
-            + filename
+            DCMTK_LOG4CPLUS_TEXT("Renaming file ") 
+            + filename 
             + DCMTK_LOG4CPLUS_TEXT(" to ")
             + target);
         ret = file_rename (filename, target);
@@ -438,6 +595,9 @@ DailyRollingFileAppender::DailyRollingFileAppender(
     const tstring& filename_, DailyRollingFileSchedule schedule_,
     bool immediateFlush_, int maxBackupIndex_)
     : FileAppender(filename_, STD_NAMESPACE ios::app, immediateFlush_)
+    , schedule()
+    , scheduledFilename()
+    , nextRolloverTime()
     , maxBackupIndex(maxBackupIndex_)
 {
     init(schedule_);
@@ -446,13 +606,16 @@ DailyRollingFileAppender::DailyRollingFileAppender(
 
 
 DailyRollingFileAppender::DailyRollingFileAppender(
-    const Properties& properties, tstring& error)
-    : FileAppender(properties, error, STD_NAMESPACE ios::app)
+    const Properties& properties)
+    : FileAppender(properties, STD_NAMESPACE ios::app)
+    , schedule()
+    , scheduledFilename()
+    , nextRolloverTime()
     , maxBackupIndex(10)
 {
     DailyRollingFileSchedule theSchedule = DAILY;
-    tstring scheduleStr = properties.getProperty(DCMTK_LOG4CPLUS_TEXT("Schedule"));
-    scheduleStr = toUpper(scheduleStr);
+    tstring scheduleStr (helpers::toUpper (
+        properties.getProperty (DCMTK_LOG4CPLUS_TEXT ("Schedule"))));
 
     if(scheduleStr == DCMTK_LOG4CPLUS_TEXT("MONTHLY"))
         theSchedule = MONTHLY;
@@ -467,15 +630,14 @@ DailyRollingFileAppender::DailyRollingFileAppender(
     else if(scheduleStr == DCMTK_LOG4CPLUS_TEXT("MINUTELY"))
         theSchedule = MINUTELY;
     else {
-        getLogLog().warn(  DCMTK_LOG4CPLUS_TEXT("DailyRollingFileAppender::ctor()- \"Schedule\" not valid: ")
-                         + properties.getProperty(DCMTK_LOG4CPLUS_TEXT("Schedule")));
+        helpers::getLogLog().warn(
+            DCMTK_LOG4CPLUS_TEXT("DailyRollingFileAppender::ctor()")
+            DCMTK_LOG4CPLUS_TEXT("- \"Schedule\" not valid: ")
+            + properties.getProperty(DCMTK_LOG4CPLUS_TEXT("Schedule")));
         theSchedule = DAILY;
     }
-
-    if(properties.exists( DCMTK_LOG4CPLUS_TEXT("MaxBackupIndex") )) {
-        tstring tmp = properties.getProperty(DCMTK_LOG4CPLUS_TEXT("MaxBackupIndex"));
-        maxBackupIndex = atoi(DCMTK_LOG4CPLUS_TSTRING_TO_STRING(tmp).c_str());
-    }
+    
+    properties.getInt (maxBackupIndex, DCMTK_LOG4CPLUS_TEXT("MaxBackupIndex"));
 
     init(theSchedule);
 }
@@ -483,9 +645,9 @@ DailyRollingFileAppender::DailyRollingFileAppender(
 
 
 void
-DailyRollingFileAppender::init(DailyRollingFileSchedule schedule_)
+DailyRollingFileAppender::init(DailyRollingFileSchedule sch)
 {
-    this->schedule = schedule_;
+    this->schedule = sch;
 
     Time now = Time::gettimeofday();
     now.usec(0);
@@ -568,7 +730,7 @@ void
 DailyRollingFileAppender::append(const spi::InternalLoggingEvent& event)
 {
     if(event.getTimestamp() >= nextRolloverTime) {
-        rollover();
+        rollover(true);
     }
 
     FileAppender::append(event);
@@ -577,8 +739,22 @@ DailyRollingFileAppender::append(const spi::InternalLoggingEvent& event)
 
 
 void
-DailyRollingFileAppender::rollover()
+DailyRollingFileAppender::rollover(bool alreadyLocked)
 {
+    helpers::LockFileGuard guard;
+
+    if (useLockFile && ! alreadyLocked)
+    {
+        try
+        {
+            guard.attach_and_lock (*lockFile);
+        }
+        catch (STD_NAMESPACE runtime_error const &)
+        {
+            return;
+        }
+    }
+
     // Close the current file
     out.close();
     out.clear(); // reset flags since the C++ standard specified that all the
@@ -594,10 +770,10 @@ DailyRollingFileAppender::rollover()
     // already exists rename it to "log.2009-11-07.1"
     tostringstream backup_target_oss;
     backup_target_oss << scheduledFilename << DCMTK_LOG4CPLUS_TEXT(".") << 1;
-    OFSTRINGSTREAM_GETOFSTRING(backup_target_oss, backupTarget)
+    tstring backupTarget(backup_target_oss.str().c_str(), backup_target_oss.str().length());
 
-    LogLog & loglog = getLogLog();
-    int ret;
+    helpers::LogLog & loglog = helpers::getLogLog();
+    long ret;
 
 #if defined (_WIN32)
     // Try to remove the target first. It seems it is not
@@ -614,12 +790,12 @@ DailyRollingFileAppender::rollover()
     // possible to rename over existing file, e.g. "log.2009-11-07".
     ret = file_remove (scheduledFilename);
 #endif
-
+   
     // Rename filename to scheduledFilename,
     // e.g. rename "log" to "log.2009-11-07".
     loglog.debug(
         DCMTK_LOG4CPLUS_TEXT("Renaming file ")
-        + filename
+        + filename 
         + DCMTK_LOG4CPLUS_TEXT(" to ")
         + scheduledFilename);
     ret = file_rename (filename, scheduledFilename);
@@ -630,7 +806,7 @@ DailyRollingFileAppender::rollover()
     loglog_opening_result (loglog, out, filename);
 
     // Calculate the next rollover time
-    Time now = Time::gettimeofday();
+    log4cplus::helpers::Time now = Time::gettimeofday();
     if (now >= nextRolloverTime)
     {
         scheduledFilename = getFilename(now);
@@ -645,7 +821,7 @@ DailyRollingFileAppender::calculateNextRolloverTime(const Time& t) const
 {
     switch(schedule)
     {
-    case MONTHLY:
+    case MONTHLY: 
     {
         struct tm nextMonthTime;
         t.localtime(&nextMonthTime);
@@ -654,7 +830,7 @@ DailyRollingFileAppender::calculateNextRolloverTime(const Time& t) const
 
         Time ret;
         if(ret.setTime(&nextMonthTime) == -1) {
-            getLogLog().error(
+            helpers::getLogLog().error(
                 DCMTK_LOG4CPLUS_TEXT("DailyRollingFileAppender::calculateNextRolloverTime()-")
                 DCMTK_LOG4CPLUS_TEXT(" setTime() returned error"));
             // Set next rollover to 31 days in future.
@@ -668,7 +844,7 @@ DailyRollingFileAppender::calculateNextRolloverTime(const Time& t) const
         return (t + Time(7 * 24 * 60 * 60));
 
     default:
-        getLogLog ().error (
+        helpers::getLogLog ().error (
             DCMTK_LOG4CPLUS_TEXT ("DailyRollingFileAppender::calculateNextRolloverTime()-")
             DCMTK_LOG4CPLUS_TEXT (" invalid schedule value"));
         // Fall through.
@@ -704,7 +880,7 @@ DailyRollingFileAppender::getFilename(const Time& t) const
         break;
 
     default:
-        getLogLog ().error (
+        helpers::getLogLog ().error (
             DCMTK_LOG4CPLUS_TEXT ("DailyRollingFileAppender::getFilename()-")
             DCMTK_LOG4CPLUS_TEXT (" invalid schedule value"));
         // Fall through.
@@ -733,5 +909,4 @@ DailyRollingFileAppender::getFilename(const Time& t) const
 }
 
 } // namespace log4cplus
-
-} // namespace dcmtk
+} // end namespace dcmtk
diff --git a/oflog/libsrc/fileinfo.cc b/oflog/libsrc/fileinfo.cc
new file mode 100644
index 0000000..b8cd189
--- /dev/null
+++ b/oflog/libsrc/fileinfo.cc
@@ -0,0 +1,74 @@
+// -*- C++ -*-
+//
+//  Copyright (C) 2012, Vaclav Zeman. All rights reserved.
+//
+//  Redistribution and use in source and binary forms, with or without modifica-
+//  tion, are permitted provided that the following conditions are met:
+//
+//  1. Redistributions of  source code must  retain the above copyright  notice,
+//     this list of conditions and the following disclaimer.
+//
+//  2. Redistributions in binary form must reproduce the above copyright notice,
+//     this list of conditions and the following disclaimer in the documentation
+//     and/or other materials provided with the distribution.
+//
+//  THIS SOFTWARE IS PROVIDED ``AS IS'' AND ANY EXPRESSED OR IMPLIED WARRANTIES,
+//  INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND
+//  FITNESS  FOR A PARTICULAR  PURPOSE ARE  DISCLAIMED.  IN NO  EVENT SHALL  THE
+//  APACHE SOFTWARE  FOUNDATION  OR ITS CONTRIBUTORS  BE LIABLE FOR  ANY DIRECT,
+//  INDIRECT, INCIDENTAL, SPECIAL,  EXEMPLARY, OR CONSEQUENTIAL  DAMAGES (INCLU-
+//  DING, BUT NOT LIMITED TO, PROCUREMENT  OF SUBSTITUTE GOODS OR SERVICES; LOSS
+//  OF USE, DATA, OR  PROFITS; OR BUSINESS  INTERRUPTION)  HOWEVER CAUSED AND ON
+//  ANY  THEORY OF LIABILITY,  WHETHER  IN CONTRACT,  STRICT LIABILITY,  OR TORT
+//  (INCLUDING  NEGLIGENCE OR  OTHERWISE) ARISING IN  ANY WAY OUT OF THE  USE OF
+//  THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+
+#include "dcmtk/oflog/config.h"
+#include "dcmtk/oflog/helpers/fileinfo.h"
+
+#ifdef DCMTK_LOG4CPLUS_HAVE_SYS_TYPES_H
+#include <sys/types.h>
+#endif
+#ifdef DCMTK_LOG4CPLUS_HAVE_SYS_STAT_H
+#include <sys/stat.h>
+#endif
+
+#if defined (_WIN32)
+#include <tchar.h>
+#include "dcmtk/oflog/config/windowsh.h"
+#endif
+
+
+namespace dcmtk {
+namespace log4cplus { namespace helpers {
+
+
+int
+getFileInfo (FileInfo * fi, tstring const & name)
+{
+#if defined (_WIN32)
+    struct _stat fileStatus;
+    if (_tstat (name.c_str (), &fileStatus) == -1)
+        return -1;
+    
+    fi->mtime = helpers::Time (fileStatus.st_mtime);
+    fi->is_link = false;
+    fi->size = fileStatus.st_size;
+    
+#else
+    struct stat fileStatus;
+    if (stat (DCMTK_LOG4CPLUS_TSTRING_TO_STRING (name).c_str (),
+            &fileStatus) == -1)
+        return -1;
+
+    fi->mtime = helpers::Time (fileStatus.st_mtime);
+    fi->is_link = S_ISLNK (fileStatus.st_mode);
+    fi->size = fileStatus.st_size;
+    
+#endif
+    
+    return 0;
+}
+
+} } // namespace log4cplus { namespace helpers {
+} // end namespace dcmtk
